#!/usr/bin/perl -w

my $threshold = $ARGV[2];
my $mafthres = $ARGV[3];

open(IN,$ARGV[0]);
open(OUT,">" . $ARGV[1]);
my $line = <IN>;
print OUT $line;

my $pass = 0;
while ($line = <IN>)
{
	chomp($line);
	@parts = split(/\t/, $line);
	# $p tracks whether to keep
	my $p = 1;
	
	my @alleles = split(/\//,$parts[1]);
	# If we don't have two alleles (i.e. it's not biallelic, don't keep)
	if (scalar(@alleles) != 2)
	{
		$p = 0;
	}
	# If we have a gap as one of the alleles don't keep
	if ('-' ~~ @alleles)
	{
		$p = 0;
	}
	
	# $c number of unknowns, $nc number of knowns, %m counts for each allele
	my $c = 0;
	my $nc = 0;
	my %m;
	for (my $i = 11; $i < scalar(@parts); $i++)
	{
		if ($parts[$i] eq "N")
		{
			$c++;
		}
		else
		{
			$m{$parts[$i]} ++;
			$nc++;
		}
	}
	# If we have too many missing don't keep
	my $miss = $c / (scalar(@parts) - 11);
	if ($miss > $threshold)
	{
		$p = 0;
	}
	
	# If the MAF is too low don't keep
	foreach my $n (values(%m)) 
	{
		my $maf = $n / $nc;
		if ($maf < $mafthres)
		{
			$p = 0;
		}
	}
	
	# If we have only one code in the alleles don't keep
	# Can't remember why this is needed as a separate step from the biallelic check above
	if (scalar(keys(%m)) == 1)
	{
		$p = 0;
	}
	
	# If we are keeping the SNP output it and keep count
	if ($p)
	{
		$pass++;
		print OUT $line . "\n";
	}
}
close(IN);
close(OUT);

print $pass . "\n";
